(******************************************************************************
*                                  dateUnit                                   *
* date manipulation                                                           *
******************************************************************************)
unit dateUnit;

interface

function  gregToJul(M,D,Y : longint): longint;
procedure julToGreg(jul:longint; var M,D,Y: longint);

implementation

(******************************************************************************
*                                  GregtoJul                                  *
******************************************************************************)
function gregToJul;
var 
   factor: integer;
begin
   if (M < 3) then
      factor := -1
   else
      factor := 0;
   gregToJul :=  (1461*(factor+4800+Y) div 4)
               + ((M-2-(factor*12))*367) div 12
               - (3*((Y+4900+factor) div 100) div 4)
               + D
               - 32075;
end; {gregToJul}

(******************************************************************************
*                                  JultoGreg                                  *
******************************************************************************)
procedure JultoGreg;
var 
   U,V,W,X: longint;
begin
   inc(jul, 68569);
   W := (jul*4) div 146097;
   dec(jul,((146097*W)+3) div 4);
   X := 4000*succ(jul) div 1461001;
   dec(jul,((1461*X) div 4) - 31);
   V := 80*jul div 2447;
   U := V div 11;
   D := jul - (2447*V div 80);
   M := V + 2 - (U*12);
   Y := X + U + (W-49)*100;
end; {julToGreg}

end.
