(******************************************************************************
*                                  dbEngBas                                   *
* the database base engine object is defined here                             *
******************************************************************************)
unit dbEngBas;

interface

const
   openConnections : word = 0;


type
   databaseEnginePtr = ^ databaseEngine;
   databaseEngine = object

      constructor init;
      destructor done; virtual;

      procedure gregorianToDate(m, d, y : integer; var dt); virtual;
      procedure dateToGregorian(const dt; var m, d, y : integer); virtual;

   end; { databaseEngine object definition }

implementation

(******************************************************************************
*                             databaseEngine.init                             *
******************************************************************************)
constructor databaseEngine.init;
begin
   inc(openConnections); { counts the number of open connections .. }
end; {databaseEngine.init}

(******************************************************************************
*                             databaseEngine.done                             *
******************************************************************************)
destructor databaseEngine.done;
begin
   dec(openConnections);
end; {databaseEngine.done}

(******************************************************************************
*                       databaseEngine.gregorianToDate                        *
******************************************************************************)
procedure databaseEngine.gregorianToDate;
begin
   (* descendents will over-ride .. *)
end; {databaseEngine.gregorianToDate}

(******************************************************************************
*                       databaseEngine.dateToGregorian                        *
******************************************************************************)
procedure databaseEngine.dateToGregorian;
begin
   (* descendents will over-ride .. *)
end; {databaseEngine.dateToGregorian}

end.
